/*
MIT License

Copyright (c) 2018-2019 Daniel Cortes

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/

drop table if exists egresos;
drop table if exists tipos_egreso;
drop table if exists ingresos;
drop table if exists tipos_ingreso;
drop table if exists efectivos;
drop table if exists documentos;
drop table if exists caja;

create table caja
(
  id    int(10) unsigned primary key auto_increment,
  fecha date not null
);

create table tipos_egreso
(
  id     int(10) unsigned primary key auto_increment,
  nombre varchar(191) not null
);

create table egresos
(
  id             int(10) unsigned primary key auto_increment,
  nro            varchar(191)     not null,
  descripcion    varchar(191)     not null,
  valor          int(10)          not null,
  tipo_egreso_id int(10) unsigned not null,
  caja_id        int(10) unsigned not null,
  foreign key fk_egresos_tipo_egreso (tipo_egreso_id) references tipos_egreso (id) on update cascade on delete restrict,
  foreign key fk_egresos_caja (caja_id) references caja (id) on update cascade on delete restrict
);

create table tipos_ingreso
(
  id     int(10) unsigned primary key auto_increment,
  nombre varchar(191) not null
);

create table ingresos
(
  id              int(10) unsigned primary key auto_increment,
  valor           int(10)          not null,
  nro_inicial     varchar(191)     not null,
  nro_final       varchar(191)     not null,
  tipo_ingreso_id int(10) unsigned not null,
  caja_id         int(10) unsigned not null,
  foreign key fk_tipo_ingreso (tipo_ingreso_id) references tipos_ingreso (id) on update cascade on delete restrict,
  foreign key fk_ingresos_caja (caja_id) references caja (id) on update cascade on delete restrict
);

create table efectivos
(
  id         int(10) unsigned primary key auto_increment,
  veinte_mil int(10)          not null,
  diez_mil   int(10)          not null,
  cinco_mil  int(10)          not null,
  dos_mil    int(10)          not null,
  mil        int(10)          not null,
  quinientos int(10)          not null,
  cien       int(10)          not null,
  cincuenta  int(10)          not null,
  diez       int(10)          not null,
  caja_id    int(10) unsigned not null,
  foreign key fk_efectivos_caja (caja_id) references caja (id) on update cascade on delete restrict
);

create table documentos
(
  id       int(10) unsigned primary key auto_increment,
  cheques  int(10)          not null,
  tarjetas int(10)          not null,
  caja_id  int(10) unsigned not null,
  foreign key fk_documentos_caja (caja_id) references caja (id) on update cascade on delete restrict
);


insert into tipos_egreso (nombre)
values ('Factura Materia Prima'),
       ('Factura Gastos Generales'),
       ('Gasto Menor Materia Prima'),
       ('Gasto General Sin Respaldo'),
       ('Gasto General Con Boleta'),
       ('Guia Materia Prima'),
       ('Anticipo Arriendo'),
       ('Anticipo Personal'),
       ('Pago Partime'),
       ('Retiros Gerencia'),
       ('Otro');

insert into tipos_ingreso (nombre)
values ('Boletas Fiscales'),
       ('Boletas Manuales'),
       ('Facturas'),
       ('Guias')

